#ifndef ERROR_H
#define ERROR_H

#include <string>

namespace kyai {
namespace assistant {

enum class ErrorCode {
    Ok = 0,
    NetError,
    ServerError,
    UnAuthorized,
    RequestTooMany,
    RequestFailed,
    InputTextLengthInvaild,
    TaskTimeout,
    GenerateImageFailed,
    GenerateImageBlocked,
    ParamError,
    InputTextInvaild,
    FileNotFound,
    IntentServerError,
    NlpServerError,
    VisionServerError,
    UnknownError,
};

class Error {
public:
    ErrorCode code = ErrorCode::Ok;
    std::string message{};
    explicit operator bool() const { return code != ErrorCode::Ok; }

    static ErrorCode getCodeFromNlpError(int errorCode);
    static ErrorCode getCodeFromVisionError(int errorCode);
};

}  // namespace assistant
}  // namespace kyai

#endif  // ERROR_H
